# Building TELEMAC-MASCARET on Windows

This provides a set of scripts and a configuration file allowing to build TELEMAC-MASCARET on Windows using Mingw-w64.

## Prerequisites:

- **Git**: download it from [gitforwindows.org](https://gitforwindows.org/) and install it with the LFS extension.
- **CMake**: install the latest 64 bits version available from [cmake.org](https://cmake.org), and be sure that CMake is added to your PATH environment variable.<br>
Note: to install CMake without administrator rights, you need to download and extract the zip file.
- **Mingw-w64**: download the 8.5 version from [winlibs](https://github.com/brechtsanders/winlibs_mingw/releases/download/8.5.0-9.0.0-r1/winlibs-x86_64-posix-seh-gcc-8.5.0-mingw-w64-9.0.0-r1.zip) and extract it to `C:\`.<br>
Note: if you don't install Mingw-w64 in `C:\`, you will need to add its `bin` directory to your `PATH`.

## Building and installing TELEMAC-MASCARET dependencies

TELEMAC-MASCARET can be built with or without several dependencies, which are listed below:
- MED (requires HDF5)
- METIS
- MPI
- MUMPS (requires MPI, LAPACK and ScaLAPACK)
- AED2
- GOTM

These dependencies can be installed using the provided `build-telemac-deps.bat` script, as follows:
```
C:\>build-telemac-deps C:\telemac-deps
```

This will **download** and **build** all dependencies, and **install** them to the provided path, which is `C:\telemac-deps` in this example.

## Building TELEMAC-MASCARET

Once you have built the dependencies, you can build TELEMAC-MASCARET:
- Clone the repository:
```
C:\>git clone https://gitlab.pam-retd.fr/otm/telemac-mascaret.git
```
- Copy the content of this repository `config` directory (pysources and systel configuration file) to TELEMAC-MASCARET `configs` directory:
```
C:\>xcopy /e/y wintel\config telemac-mascaret\configs\
```
- Edit both pysource batches to set the dependencies path, such as below:
```
set TELEMACDEPS=C:\telemac-deps
```
- Setup TELEMAC-MASCARET environment by launching one of the pysource batch:
```
C:\>telemac-mascaret\configs\pysource.win.bat
```
- Build TELEMAC-MASCARET:
```
C:\>compile_telemac.py
```
